javax.resource.cci

## Interface Interaction

-     public interface Interaction

  The `javax.resource.cci.Interaction` enables a component to execute EIS functions. An Interaction instance supports the following ways of interacting with an EIS instance:
  - `execute` method that takes an input Record, output Record and an InteractionSpec. This method executes the EIS function represented by the InteractionSpec and updates the output Record
  - `execute` method that takes an input Record and an InteractionSpec. This method implementation executes the EIS function represented by the InteractionSpec and produces the output Record as a return value.

  An Interaction instance is created from a Connection and is required to maintain its association with the Connection instance. The close method releases all resources maintained by the resource adapter for the Interaction. The close of an Interaction instance should not close the associated Connection instance.

  Since:
    0.8
  Version:
    0.8
  Author:
    Rahul Sharma
  See Also:
    `ResultSet`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clearWarnings()` Clears all the warning reported by this Interaction instance.
    `void` | `close()` Closes the current Interaction and release all the resources held for this instance by the resource adapter.
    `Record` | `execute(InteractionSpec ispec, Record input)` Executes an interaction represented by the InteractionSpec.
    `boolean` | `execute(InteractionSpec ispec, Record input, Record output)` Executes an interaction represented by the InteractionSpec.
    `Connection` | `getConnection()` Gets the Connection associated with the Interaction.
    `ResourceWarning` | `getWarnings()` Gets the first ResourceWarning from the chain of warnings associated with this Interaction instance.

- - ### Method Detail

    - #### close

          void close()
                     throws ResourceException

      Closes the current Interaction and release all the resources held for this instance by the resource adapter. The close of an Interaction instance does not close the associated Connection instance. It is recommended that Interaction instances be closed explicitly to free any held resources.
      Throws:
        `ResourceException` - Failed to close the Interaction instance. Invoking close on an already closed Interaction should also throw this exception.

    - #### getConnection

          Connection getConnection()

      Gets the Connection associated with the Interaction.
      Returns:
        Connection instance associated with the Interaction

    - #### execute

          boolean execute(InteractionSpec ispec,
                        Record input,
                        Record output)
                          throws ResourceException

      Executes an interaction represented by the InteractionSpec. This form of invocation takes an input Record and updates the output Record.
      Parameters:
        `ispec` - InteractionSpec representing a target EIS data/function module
        `input` - Input Record
        `output` - Output Record
      Returns:
        true if execution of the EIS function has been successful and output Record has been updated; false otherwise
      Throws:
        `ResourceException` - Exception if execute operation fails. Examples of error cases are:
        - Resource adapter internal, EIS-specific or communication error
        - Invalid specification of an InteractionSpec, input or output record structure
        - Errors in use of input or output Record
        - Invalid connection associated with this Interaction
        `NotSupportedException` - Operation not supported

    - #### execute

          Record execute(InteractionSpec ispec,
                       Record input)
                         throws ResourceException

      Executes an interaction represented by the InteractionSpec. This form of invocation takes an input Record and returns an output Record if the execution of the Interaction has been successfull.
      Parameters:
        `ispec` - InteractionSpec representing a target EIS data/function module
        `input` - Input Record
      Returns:
        output Record if execution of the EIS function has been successful; null otherwise
      Throws:
        `ResourceException` - Exception if execute operation fails. Examples of error cases are:
        - Resource adapter internal, EIS-specific or communication error
        - Invalid specification of an InteractionSpec or input record structure
        - Errors in use of input Record or creation of an output Record
        - Invalid connection associated with this Interaction
        `NotSupportedException` - Operation not supported

    - #### getWarnings

          ResourceWarning getWarnings()
                                      throws ResourceException

      Gets the first ResourceWarning from the chain of warnings associated with this Interaction instance.
      Returns:
        ResourceWarning at top of the warning chain
      Throws:
        `ResourceException` - Failed to get ResourceWarnings associated with Interaction

    - #### clearWarnings

          void clearWarnings()
                             throws ResourceException

      Clears all the warning reported by this Interaction instance. After a call to this method, the method getWarnings will return null until a new warning is reported for this Interaction.
      Throws:
        `ResourceException` - Failed to clear ResourceWarnings associated with Interaction

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.